﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web;
using Microsoft.SharePoint.Administration;
using Microsoft.SharePoint.WebControls;
using WarmupSharePoint.Helper;

namespace RH.Warmup
{
	public partial class DownloadBatch : LayoutsPageBase
	{
		protected void Page_Load(object sender, EventArgs e)
		{
			List<string> farmUrls = GetFarmUrls();
			var assembly = typeof(WarmupSharePoint.Warmup).Assembly;
			List<string> warmupCommands = farmUrls.Select(u => string.Format("call \"{0}\" {1} AllSites", assembly.Location, u)).ToList();

			HttpResponse response = HttpContext.Current.Response;
			response.Clear();

			// Total bytes to read:
			response.Cache.SetCacheability(HttpCacheability.Private);
			response.CacheControl = "private";
			response.ContentType = "application/octet-stream";
			response.Charset = Encoding.UTF8.WebName;
			response.AddHeader("Content-Disposition", "attachment; filename=\"WarmupSharePoint.cmd\"");

			warmupCommands.ForEach(command => Page.Response.Output.WriteLine(command));

			response.Flush();
			response.End();
		}

		private static List<string> GetFarmUrls()
		{
			var farmUrls = new List<string>();
			var service = SPFarm.Local.Services.GetValue<SPWebService>(string.Empty);
			foreach (SPWebApplication webApplication in service.WebApplications)
			{
				string[] iisUrls = SharePointHelper.GetAlternatUrlForWebApplication(webApplication);
				farmUrls.AddRange(iisUrls);
			}
			return farmUrls;
		}
	}
}
