﻿; (function ($, jss) {
	var plugin = function (elem, options) {
		this.elem = elem;
		this.jElem = $(elem);
		this.options = options;
		this.metadata = this.jElem.data('plugin-options');
	};

	// the plugin prototype
	plugin.prototype = {
		defaults: {
			hour: 0,
			minute: 0,
			jHour: null,
			jMinute: null,
			jSchedule: null,
			startjobtext: '',
			startedjobtext: ''
		},

		init: function () {
			this.config = $.extend({}, this.defaults, this.options, this.metadata);

			this.createPicker();
			this._createExecueTimerjobLink();
			return this;
		},

		createPicker: function () {
			var self = this;

			// hide default TextBox
			this.jElem.hide();

			// find schedule DropDown
			self.config.jSchedule = self.jElem.parent().find('select');

			// add DropDowns for hour an minute
			self.config.jMinute = $('<select />');
			for (var i = 0; i < 60; i++) {
				$('<option />', { value: i, text: i }).appendTo(self.config.jMinute);
			}
			self.config.jMinute.val(this.config.minute);
			self.config.jMinute.prependTo(this.jElem.closest('td'));
			self.config.jMinute.on('change', function () {
				self._setValueInHiddenField(self);
			});

			self.config.jHour = $('<select />');
			for (var j = 0; j < 24; j++) {
				$('<option />', { value: j, text: j }).appendTo(self.config.jHour);
			}
			self.config.jHour.val(this.config.hour);
			self.config.jHour.prependTo(this.jElem.closest('td'));
			self.config.jHour.on('change', function () {
				self._setValueInHiddenField(self);
			});
		},

		_setValueInHiddenField: function (self) {
			self.config.hour = self.config.jHour.val();
			self.config.minute = self.config.jMinute.val();

			self.jElem.val(self.config.hour + ':' + self.config.minute);
		},

		_createExecueTimerjobLink: function () {
			var self = this;
			var jRow = self.jElem.closest('tr');
			if (jRow.data('timerjobid') != null) {
				var jCell = jRow.find('.WebApplicationName').first();
				jCell.append('<br/>');
				var link = $('<a />');
				link.click(function (event) {
					event.preventDefault();
					self._openModalDialog(self, '/_admin/JobEdit.aspx?IsDlg=1&JobId=' + jRow.data('timerjobid'));
				});
				link.text(self.config.startjobtext);
				link.attr('href', '#');
				link.appendTo(jCell);
			}
		},

		_openModalDialog: function (self, link) {
			var options = {
				url: link,
				width: 800,
				height: 600,
			};
			// supports SP2013
			SP.SOD.execute('sp.ui.dialog.js', 'SP.UI.ModalDialog.showModalDialog', options);

			// attach to click of "Run Now" Button in iframe, and close the iframe after starting the job
			$rhWarmup.$('iframe').load(function () {
				var jButton = $rhWarmup.$(this).contents().find('input[id*="_BtnRunNow"]');
				if (jButton.length == 1) {
					jButton.on('click', function () {
						// need to wait a bit, so the code-behind will start the timerjob
						setTimeout(function() {
							// close the dialog
							SP.UI.ModalDialog.commonModalDialogClose(SP.UI.DialogResult.OK);
							// show notification, so the user knows the job has been started
							SP.UI.Notify.addNotification(self.config.startedjobtext, false);
						}, 1500);
					});
				}
			});
		}
	};

	plugin.defaults = plugin.prototype.defaults;

	$.fn.rhWarmupTimePicker = function (options) {
		return this.each(function () {
			new plugin(this, options).init();
		});
	};
})($rhWarmup.$, Sys.Serialization.JavaScriptSerializer);

if (typeof (NotifyScriptLoadedAndExecuteWaitingJobs) != "undefined") {
	NotifyScriptLoadedAndExecuteWaitingJobs('rhWarmup.js');
};

