using System.Runtime.InteropServices;
using Microsoft.SharePoint;
using Microsoft.SharePoint.Administration;

namespace RH.Warmup.Features.AddCustomAction
{
	/// <summary>
	/// This class handles events raised during feature activation, deactivation, installation, uninstallation, and upgrade.
	/// </summary>
	/// <remarks>
	/// The GUID attached to this class may be used during packaging and should not be modified.
	/// </remarks>

	[Guid("94e88b26-744a-4581-ba94-f2dd5b66d80b")]
	public class AddCustomActionEventReceiver : SPFeatureReceiver
	{
		public override void FeatureActivated(SPFeatureReceiverProperties properties)
		{
			SPFeatureCollection features = SPAdministrationWebApplication.Local.Sites[0].Features;
			if (features[Constants.CustomActionFeatureId] == null)
			{
				features.Add(Constants.CustomActionFeatureId);
			}
		}

		public override void FeatureDeactivating(SPFeatureReceiverProperties properties)
		{
			SPFeatureCollection features = SPAdministrationWebApplication.Local.Sites[0].Features;
			if (features[Constants.CustomActionFeatureId] != null)
			{
				features.Remove(Constants.CustomActionFeatureId);
			}
		}

		public override void FeatureUninstalling(SPFeatureReceiverProperties properties)
		{
			FeatureDeactivating(properties);
		}
	}
}
