﻿using System;

namespace RH.Warmup.Update
{
    public class LatestVersion
    {
        private readonly Version _version;
        private readonly DateTime _publishDate;

        public Version Version
        {
            get { return _version; }
        }

        public DateTime PublishDate
        {
            get { return _publishDate; }
        }

        public string ErrorText { get; private set; }

        public LatestVersion()
        {
        }

        public LatestVersion(string errorText)
        {
            _version = new Version();
            ErrorText = errorText;
        }

        public LatestVersion(string version, DateTime publishDate, string errorText)
        {
            _version = new Version(version);
            _publishDate = publishDate;
            ErrorText = errorText;
        }
    }
}
