﻿using System;
using System.Diagnostics;
using WarmupSharePoint.Helper;

namespace WarmupSharePoint
{
	public class Eventlog
	{
		static Eventlog()
		{
			EventlogSource = "IIS-W3SVC";
		}

		public static string EventlogSource { get; set; }

		internal static void Write(string message)
		{
			Write(message, EventLogEntryType.Information, 0);
		}

		/// <summary>
		/// 
		/// </summary>
		/// <param name="message"></param>
		/// <param name="type"></param>
		/// <param name="eventId">0 for normal Entry, 1 for an Exception</param>
		public static void Write(string message, EventLogEntryType type, int eventId)
		{
			try
			{
				if (Properties.Settings.Default.Eventlog)
				{
					// eventlog messages may not exceed 32766 bytes
					foreach (string currentMessage in message.SplitString(32766))
					{
						EventLog.WriteEntry(EventlogSource, currentMessage, type, eventId);
					}
				}
			}
			catch (Exception ex)
			{
				Console.WriteLine(ex);
			}
		}
	}
}
