﻿using System.Collections.Generic;

namespace WarmupSharePoint.Helper
{
	static class Extensions
	{
		/// <summary>
		/// split string in parts, which do not exceed numterToCut chars
		/// </summary>
		/// <param name="incomingString"></param>
		/// <param name="numberToCut"></param>
		/// <returns></returns>
		internal static IEnumerable<string> SplitString(this string incomingString, int numberToCut)
		{
			int charCount = incomingString.Length;
			var result = new List<string>();
			string temp = string.Empty;
			int curseur = 0;
			do
			{
				if (incomingString.Length <= numberToCut)
				{
					temp = incomingString;
				}
				else
				{
					for (int i = 0; i < numberToCut - 1; i++)
					{
						temp += incomingString.Substring(i + curseur, 1);
					}
				}

				result.Add(temp);
				temp = string.Empty;
				curseur += numberToCut;
			} while (charCount >= curseur + numberToCut);

			temp = string.Empty;
			for (int i = curseur; i < charCount; i++)
			{
				temp += incomingString.Substring(i, 1);
			}

			if (!string.IsNullOrEmpty(temp))
				result.Add(temp);

			return result;
		}
	}
}
