﻿using System;

namespace WarmupSharePoint.Helper
{
	public class ProgressChangeEventArgs : EventArgs
	{
		public ProgressChangeEventArgs()
		{
		}

		public ProgressChangeEventArgs(int overall, int current)
		{
			Current = current;
			Overall = overall;

			if (overall == 0)
				Progress = 100;
			else
				Progress = (int)Math.Round(((double)current / overall) * 100, 0);
		}

		/// <summary>
		/// calculate your progress yourself
		/// </summary>
		public int Current { get; set; }

		/// <summary>
		/// calculate your progress yourself
		/// </summary>
		public int Overall { get; set; }

		/// <summary>
		/// between 0 and 100
		/// </summary>
		public int Progress { get; set; }
	}
}
