﻿using System;
using System.Collections.Generic;
using System.Runtime.Serialization;

namespace WarmupSharePoint
{
	//[DataContract]
	public class Settings : List<Setting>
	{
		[DataMember]
		public bool WarmupSearch { get; set; }

		[DataMember]
		public string QueryKeyword { get; set; }

		[DataMember]
		public bool EventLog { get; set; }

		public string WebApplicationUrl { get; set; }

		/// <summary>
		/// allow Setting to be assigned directly to Settings
		/// </summary>
		/// <param name="setting"></param>
		/// <returns></returns>
		public static implicit operator Settings(Setting setting)
		{
			return new Settings
			{
				EventLog = setting.EventLog,
				QueryKeyword = setting.QueryKeyword,
				WarmupSearch = setting.WarmupSearch,
				WebApplicationUrl = setting.WebApplicationUrl
			};
		}
	}

	[DataContract]
	public class Setting
	{
		// properties for Application Page in CA
		public bool Activated { get; set; }
		public string Name { get; set; }
		public string WebApplicationUrl { get; set; }
		public Guid TimerJobId { get; set; }

		// properties which will be stored in PropertyBags
		[DataMember]
		public Guid WebApplicationId { get; set; }

		[DataMember]
		public bool WarmupSearch { get; set; }

		[DataMember]
		public string QueryKeyword { get; set; }

		[DataMember]
		public bool EventLog { get; set; }

		/// <summary>
		/// Hour and Minutes are used to create the TimerJob
		/// </summary>
		[DataMember]
		public DateTime Time { get; set; }

		/// <summary>
		/// in hours
		/// </summary>
		[DataMember]
		public int Schedule { get; set; }
	}
}
